/* 
designmatrix_with_dct_basisfunctions.js; H.Breman 08-08-13 and R.Goebel 
*/
 
CreateDesignMatrix_DCT_confound(); 

function CreateDesignMatrix_DCT_confound() { 

    BrainVoyagerQX.PrintToLog("Create single subject design matrix with 5 DCT basis functions..."); 
    var doc = BrainVoyagerQX.ActiveDocument; 
    // >> link protocol (and if necessary, a VTC)
    //doc.LinkVTC(); 
    //doc.LinkStimulationProtocol(); 

    doc.ClearDesignMatrix();
    doc.SDMContainsConstantPredictor = 0;
    doc.FirstConfoundPredictorOfSDM = 1; // >>> adapt this by adding the number of predictors of interest
	var experimentName = "vision_subj1";

    // >> generate here the predictors of interest
    
    // generate the DCT confound predictors
    var period; // number of periods in 1 time course (number of volumes)
    var predictorname;
    var noVols = doc.NrOfVolumes; // number of volumes for BVQX example data
    BrainVoyagerQX.PrintToLog("Number of volumes: " + noVols);

    var periods = [0.5, 1, 1.5, 2, 2.5]; // here we choose 5 standard basis functions
    for (var j=0; j<periods.length; j++) {

        predictorname="DCT " + (j+1);
        doc.AddPredictor(predictorname); 
        BrainVoyagerQX.PrintToLog("Period: " + periods[j]);

        for (i = 1; i<= noVols; i++) { 
            period=periods[j];
            value = Math.cos(i/((noVols/period)/(Math.PI*2)));
            fromVol=i;
            toVol=i;
            doc.SetPredictorValues(predictorname, fromVol, toVol, value); 
        }
    }

    doc.SaveSingleStudyGLMDesignMatrix(experimentName + "script_DCT_basis_functions.sdm"); 
}